from django.shortcuts import render
from django.views.generic import ListView, DetailView
from django.contrib.auth.mixins import LoginRequiredMixin

from .models import Service


class ServiceMixin:
    def get_queryset(self):
        return Service.objects.filter(adherent__pk__in=self.request.user.profile.adhesions.values_list('pk')) \
                    .order_by('-start')


class ServiceList(LoginRequiredMixin, ServiceMixin, ListView):
    pass


class ServiceDetail(LoginRequiredMixin, ServiceMixin, DetailView):
    pass
